<template>
  <v-app>
    <v-data-table
      v-model="selected"
      :headers="headers"
      :items="result"
      :single-select="singleSelect"
      item-key="id"
      style="padding:23px"
    >
      <template v-slot:top>
        <div>
          <div>
            <h3>{{ title }}</h3>
          </div>

          <v-layout row>
            <v-flex md8>
              <v-col cols="12" sm="12" md="5">
                <v-text-field
                  label="Solo"
                  v-model="description"
                  rounded
                  placeholder="Search"
                  solo
                  append-icon="search"
                  v-on:keyup.enter="getData()"
                  @click:append="getData()"
                ></v-text-field>
              </v-col>
            </v-flex>

            <v-flex md4>
              <div align="right">
                <v-menu offset-y transition="slide-y-transition">
                  <template v-slot:activator="{ on }">
                    <v-btn icon v-on="on" class="mr-1 mt-2">
                      <v-icon>mdi-filter-variant</v-icon>
                    </v-btn>
                  </template>
                  <v-card>
                    <v-list>
                      <v-list-item-group>
                        <v-list-item disabled>
                          <v-list-item-title style="width:180px">
                            Search By
                          </v-list-item-title>
                        </v-list-item>

                        <v-divider></v-divider>

                        <v-list-item
                          v-for="(item, index) in item_menu"
                          :key="index"
                          v-on:click="searchBy(item.val)"
                        >
                          <v-list-item-title>
                            {{ item.title }}
                          </v-list-item-title>
                        </v-list-item>
                      </v-list-item-group>
                    </v-list>
                  </v-card>
                </v-menu>

                <v-menu
                  v-model="menu"
                  :close-on-content-click="false"
                  :nudge-width="200"
                  offset-y
                >
                  <template v-slot:activator="{ on, attrs }">
                    <v-btn icon v-bind="attrs" v-on="on" class="mr-4 mt-2">
                      <v-icon>mdi-sort</v-icon>
                    </v-btn>
                  </template>

                  <v-card>
                    <v-list>
                      <v-list-item disabled>
                        <v-list-item-action>
                          Sort By
                        </v-list-item-action>
                      </v-list-item>
                    </v-list>
                    <v-divider></v-divider>

                    <v-list>
                      <v-list-item>
                        <v-list-item-title>
                          <v-radio-group v-model="sort_type" row class="ml-2">
                            <v-radio label="Asc" value="1"></v-radio>
                            <v-radio label="Desc" value="0"></v-radio>
                          </v-radio-group>
                        </v-list-item-title>
                      </v-list-item>
                      <v-divider></v-divider>

                      <v-list-item-group>
                        <v-list-item
                          v-for="(item, index) in item_menu"
                          :key="index"
                          v-on:click="setVal(item.val)"
                        >
                          <v-list-item-title>{{
                            item.title
                          }}</v-list-item-title>
                        </v-list-item>
                      </v-list-item-group>
                    </v-list>

                    <v-card-actions>
                      <v-spacer></v-spacer>
                      <v-btn text @click="menu = false">Close</v-btn>
                      <v-btn color="primary" text @click="getData()"
                        >Sort</v-btn
                      >
                    </v-card-actions>
                  </v-card>
                </v-menu>
                <v-btn rounded dark class="btn-add" large @click="modalOpen()">
                  Create New Account
                </v-btn>
              </div>
            </v-flex>
          </v-layout>
        </div>

        <Form v-model="dialog" @event="modalProcess" />
        <Detail v-model="detail" @event="modalDetail" />
      </template>

      <template v-slot:item.action="{ item }">
        <div>
          <v-menu offset-y>
            <template v-slot:activator="{ on, attrs }">
              <v-btn color="#90ba45" dark small v-bind="attrs" v-on="on">
                Action
              </v-btn>
            </template>
            <v-list>
              <v-list-item-group>
                <v-list-item @click="detailOpen(item)">
                  <v-list-item-title style="width:120px">
                    <v-icon class="mr-2">mdi-eye-outline</v-icon> View
                  </v-list-item-title>
                </v-list-item>

                <v-list-item @click="modalOpen(item)">
                  <v-list-item-title>
                    <v-icon class="mr-2">mdi-file-edit-outline</v-icon> Edit
                  </v-list-item-title>
                </v-list-item>

                <v-list-item @click="deleteItem(item)">
                  <v-list-item-title>
                    <v-icon class="mr-2">mdi-delete-outline</v-icon>Delete
                  </v-list-item-title>
                </v-list-item>
              </v-list-item-group>
            </v-list>
          </v-menu>
        </div>
      </template>
    </v-data-table>
  </v-app>
</template>

<script>
import Form from "./Form";
import Detail from "./Detail";

export default {
  methods: {
    async getData() {
      let self = this;
      let res = null;
      let sort_field = self.sort_field;
      let sort_type = self.sort_type;
      let page = self.page;
      let per_page = self.per_page;
      let description = self.description;
      let search_by = self.search_by;
      self.menu = false;
      let url =
        self.base_url +
        "api/v1/finance-accounts?" +
        search_by +
        "=" +
        description +
        "&sort_field=" +
        sort_field +
        "&sort_type=" +
        sort_type +
        "&page=" +
        page +
        "&per_page=" +
        per_page;

      try {
        res = await self.axios.get(url, {
          headers: {
            Authorization: "Bearer " + self.token,
            "Content-Type": "application/json;charset=UTF-8",
          },
        });
      } catch (err) {
        alert(JSON.stringify(err.response.data));
      } finally {
        self.result = res.data["data"];
        console(res);
      }
    },
    deleteItem(item) {
      let self = this;
      let url = self.base_url + "api/v1/finance-accounts/" + item.id;
      let res = null;
      let text_confirm = "Are you sure you delete this data ?";

      this.$dialog.confirm({
        text: text_confirm,
        overlay: true,
        actions: {
          false: "Cancel",
          true: {
            color: "green",
            text: "Delete",
            handle: () => {
              (async () => {
                try {
                  res = await self.axios.delete(url, {
                    headers: {
                      Authorization: "Bearer " + self.token,
                      "Content-Type": "application/json;charset=UTF-8",
                    },
                  });
                } catch (err) {
                  alert(JSON.stringify(err.response.data));
                } finally {
                  self.getData();
                  console(res);
                }
              })();
            },
          },
        },
      });
    },
    modalOpen(data = "") {
      let tipe = "";
      let title = "";

      if (data) {
        tipe = "update";
        title = "Edit Account";
      } else {
        tipe = "insert";
        title = "Create New Account";
      }

      this.dialog = {
        val: true,
        data: data,
        tipe: tipe,
        title: title,
      };
    },
    detailOpen(data = "") {
      this.detail = {
        val: true,
        data: data,
      };
    },
    modalProcess(value) {
      if (value) {
        this.dialog.val = false;
        this.getData();
      }
    },
    modalDetail(value) {
      if (value) {
        this.detail.val = false;
      }
    },
    searchBy(val) {
      this.search_by = val;
      this.getData();
    },
    setVal(val) {
      this.sort_field = val;
    },
  },
  mounted() {
    this.getData();
  },
  components: {
    Form,
    Detail,
  },
  data() {
    return {
      name: "Account",
      title: "All Finance Account",
      widgets: false,
      singleSelect: true,
      selected: [],
      showSelect: false,
      modal_detail: false,
      modal_form: false,
      headers: [
        { text: "Account Name", value: "name", width: 300 },
        { text: "Description", value: "Description", width: 300 },
        { text: "Account Type", value: "type", width: 200 },
        { text: "Action", value: "action", width: 200 },
      ],
      result: [],
      dialog: [],
      detail: [],
      sort_field: "name",
      sort_type: 1,
      page: 0,
      per_page: 50,
      description: "",
      search_by: "description",
      fav: true,
      menu: false,
      message: false,
      hints: true,
      item_menu: [
        { title: "Account Name", val: "name" },
        { title: "Description", val: "description" },
        { title: "Type", val: "type" },
      ],
      token: localStorage.getItem("token")
    };
  },
};
</script>
